(define (domain block-based)
	(:requirements :typing :negative-preconditions :existential-preconditions :universal-preconditions)
	(:types location blocktype direction - object)
	(:predicates (empty ?loc - location)
		(block-at ?loc - location ?type - blocktype)
		(neighbour ?loc1 ?loc2 - location ?dir - direction) 
		(on-top ?loc1 ?loc2 - location) 
		)

	(:action place-block
	  :parameters (?loc1 ?loc2 - location ?t - blocktype)
	  :precondition (and (empty ?loc1) (not (empty ?loc2)) (or (on-top ?loc1 ?loc2) (on-top ?loc2 ?loc1) (exists (?dir - direction) (and (neighbour ?loc1 ?loc2 ?dir)))) )
	  :effect (and (not (empty ?loc1)) (block-at ?loc1 ?t)) )

	(:action remove-block
	  :parameters (?loc - location ?t - blocktype)
	  :precondition (and (not (empty ?loc)) (block-at ?loc ?t) )
	  :effect (and (empty ?loc) (not (block-at ?loc ?t))) )


	)